#version 430


//######################################################//
//### Standard inputs/uniforms for every pixelshader ###//
//######################################################//
layout(std140, binding = 0) uniform perFrame
{
	mat4x4	vp;
	mat4x4  invVP;

	mat4x4	view;
	mat4x4	invView;
	mat4x4	invTransView;

	mat4x4	proj;
	mat4x4	invProj;

	vec3	eyePos;
	float	gt;
	float	dt;
	uint	screenW;
	uint	screenH;

};

layout(location = 1) uniform mat4x4 modelToWorld;
//layout(location = 25) uniform mat4x4 modelInvTrans;

layout(location = 0) in vec2 inTex;

layout(location = 0) out vec4 oAlbedoMetal;
layout(location = 1) out vec4 oNormalDepth;
layout(location = 2) out vec4 oEmissiveRoughness;


uniform float ROUGHNESS = 1.f;
uniform float METALLNESS = 0.f;
uniform vec3 EMISSIVE = vec3(0);
uniform vec3 NORMAL = vec3(0);
uniform vec3 CLEAR_COLOR = vec3(0);
uniform float DEpTH = 1.1f; //values larger than 1 -> nothing got written to that pixel
//######################################################//
//### Standard inputs/uniforms for every pixelshader ###//
//######################################################//


void main()
{
	oAlbedoMetal = vec4(CLEAR_COLOR, METALLNESS);
	oNormalDepth = vec4(NORMAL, DEpTH);
	oEmissiveRoughness = vec4(EMISSIVE, ROUGHNESS);
}
