#version 430


//###################################################//
//### Inputs/uniforms for our gbuffer pixelshader ###//
//###################################################//
layout(std140, binding = 0) uniform perFrame
{
	mat4x4	vp;
	mat4x4  invVP;

	mat4x4	view;
	mat4x4	invView;
	mat4x4	invTransView;

	mat4x4	proj;
	mat4x4	invProj;

	vec3	eyePos;
	float	gt;
	float	dt;
	uint	screenW;
	uint	screenH;

};

uniform vec4 iColor;
uniform float iScale;
uniform mat4x4 iTransform;


layout(location = 0) in vec3 iPos;

void main()
{
	vec3 pos = iScale * iPos;
	vec4 posW = iTransform * vec4(pos, 1);
	vec4 posH = vp * posW;
	gl_Position = posH;
}
