#version 430


//###################################################//
//### Inputs/uniforms for our gbuffer pixelshader ###//
//###################################################//
layout(std140, binding = 0) uniform perFrame
{
	mat4x4	vp;
	mat4x4  invVP;

	mat4x4	view;
	mat4x4	invView;
	mat4x4	invTransView;

	mat4x4	proj;
	mat4x4	invProj;

	vec3	eyePos;
	float	gt;
	float	dt;
	uint	screenW;
	uint	screenH;

};

layout(location = 0) in vec3 iPosW;
layout(location = 1) in uint iColor;


layout(location = 0) out vec3 oPosW;
layout(location = 1) out vec3 oColor;

void main()
{
	vec4 posH = vp * vec4(iPosW, 1);
	gl_Position = posH;

	vec3 posW = posH.xyz / posH.w;
	oPosW = posW;

//	float a = float((iColor >> 24) & 0xff) / 255;
	float r = float((iColor >> 16) & 0xff) / 255;
	float g = float((iColor >>  8) & 0xff) / 255;
	float b = float((iColor >>  0) & 0xff) / 255;

//	oColor = vec4(r, g, b, a);
	oColor = vec3(r, g, b);
}