#version 430

layout(binding = 0) uniform sampler2D image;
layout(location = 0) in vec2 iTex;


//Gaussian blur after:
// https://learnopengl.com/Advanced-Lighting/Bloom
layout(location = 10) uniform bool horizontal;
uniform float weight[5] = float[] (0.227027, 0.1945946, 0.1216216, 0.054054, 0.016216);


out vec4 outColor;

void main()
{
	vec2 texelSize = 1.0 / textureSize(image, 0);
	vec3 color = texture(image, iTex).rgb * weight[0];

	if( horizontal )
    {
        for(int i = 1; i < 5; ++i)
        {
            color += texture(image, iTex + vec2(texelSize.x * i, 0.0)).rgb * weight[i];
            color += texture(image, iTex - vec2(texelSize.x * i, 0.0)).rgb * weight[i];
        }
    }
    else
    {
        for(int i = 1; i < 5; ++i)
        {
            color += texture(image, iTex + vec2(0.0, texelSize.y * i)).rgb * weight[i];
            color += texture(image, iTex - vec2(0.0, texelSize.y * i)).rgb * weight[i];
        }
    }

	outColor = vec4(color, 1);
}
