#version 430


layout(location = 0) in vec3 iPosW;
layout(location = 1) in vec3 iMiddlePoint;
layout(location = 2) in vec4 iPosH;

layout(location = 10) uniform float RADIUS = 3;
layout(location = 11) uniform float ALPHA = .5;
layout(location = 12) uniform vec3 COLOR = vec3(.21, .12, .45); //purple;

//out vec4 oColor;


//OUTPUTS
//OIT Stuff are also the output
struct perPixelData
{
	vec4	color;
	float	depth;
	uint	prev;
};

layout(binding = 0, r32ui)		uniform uimage2D headPointers;
layout(binding = 0, offset = 0)	uniform atomic_uint nextNodeCounter;
layout(binding = 0, std430)		buffer linkedPixels { perPixelData pixels[]; };

void main()
{
//	float dst = distance(iPosW, iMiddlePoint);
	float dst = distance(iPosW, iPosW);
//	float alpha = dst <= RADIUS ? 1 : 0;
	float depth = iPosH.z / iPosH.w;

//	oColor = vec4(color, .5 * alpha);
	

	uint index = atomicCounterIncrement(nextNodeCounter); //increase counter & get old value

	//only add pixel to list if there's room for it left
	if( index < pixels.length() )
	{
		uint prev = imageAtomicExchange(headPointers, ivec2(gl_FragCoord.xy), index); //exchange old pixel value with 'index'
//		pixels[index].color = vec4(color, alpha * .000001 + .5);
		pixels[index].color = vec4(COLOR, ALPHA);
		pixels[index].depth = depth;
		pixels[index].prev = prev;
	}

}
