#version 430


//#######################################################//
//### Standard inputs/uniforms for every vertexshader ###//
//#######################################################//
layout(std140, binding = 0) uniform perFrame //perFrame data is ALWAYS at binding (= slot) 0
{
	mat4x4	vp;
	mat4x4  invVP;

	mat4x4	view;
	mat4x4	invView;
	mat4x4	invTransView;

	mat4x4	proj;
	mat4x4	invProj;

	vec3	eyePos;
	float	gt;
	float	dt;

};


layout(location = 0) in vec3 iPosW; //vertices are in world space
layout(location = 1) in vec3 iMiddlePoint;

layout(location = 0) out vec3 oPosW;
layout(location = 1) out vec3 oMiddlePoint;
layout(location = 2) out vec4 oPosH;
//#######################################################//
//### Standard inputs/uniforms for every vertexshader ###//
//#######################################################//

void main()
{
	vec4 posH = vp * vec4(iPosW, 1);
	gl_Position = posH;

	oPosW = iPosW;
	oMiddlePoint = iMiddlePoint;
	oPosH = posH;
}