#version 430


//#######################################################//
//### Standard inputs/uniforms for every vertexshader ###//
//#######################################################//
layout(std140, binding = 0) uniform perFrame
{
	mat4x4	vp;
	mat4x4  invVP;

	mat4x4	view;
	mat4x4	invView;
	mat4x4	invTransView;

	mat4x4	proj;
	mat4x4	invProj;

	vec3	eyePos;
	float	gt;
	float	dt;
	uint	screenW;
	uint	screenH;

};

layout(location = 1) uniform mat4x4 modelToWorld;
layout(location = 2) uniform mat4x4 modelInvTrans;
layout(location = 3) uniform float iScale = 1.0f;


layout(location = 0) in vec3 iPos;
layout(location = 1) in vec3 iNormal;
layout(location = 2) in vec3 iTangent;
layout(location = 3) in vec3 iBitangent;
layout(location = 4) in vec2 iTex;

layout(location = 0) out vec4 oPosW;
layout(location = 1) out vec4 oPosH;
layout(location = 2) out vec3 oNormal;
layout(location = 3) out vec3 oTangent;
layout(location = 4) out vec3 oBitangent;
layout(location = 5) out vec2 oTex;
//#######################################################//
//### Standard inputs/uniforms for every vertexshader ###//
//#######################################################//


void main()
{
	vec3 pos = iPos * iScale;
	vec4 posW = modelToWorld * vec4(pos, 1);
	vec4 posH = vp * posW;

	gl_Position = posH;
	oPosW = posW;
	oPosH = posH;
//	modelInvTrans;
	oNormal = normalize((modelInvTrans * vec4(iNormal, 0)).xyz);
	oTangent = normalize((modelInvTrans * vec4(iTangent, 0)).xyz);
	oBitangent = normalize((modelInvTrans * vec4(iBitangent, 0)).xyz);
	oTex = iTex;
}
