#version 430

layout(binding = 0) uniform sampler2D texBackbuffer;
layout(location = 0) in vec2 inTex;

layout(location = 10) uniform float brightness = 1;
layout(location = 11) uniform float exposure = 1;
layout(location = 12) uniform bool enableBrightness = false;
layout(location = 13) uniform bool enableExposure = false;

out vec4 outColor;

void main()
{
	vec3 color = texture(texBackbuffer, inTex).rgb;

	//Tone mapping after:
	// https://learnopengl.com/Advanced-Lighting/HDR
	if( enableExposure )
		color = 1 - exp(-color * exposure);

	//brightness correction
	if( enableBrightness )
		color = pow(color, vec3(1 / brightness));

	outColor = vec4(color, 1);
//	outColor = vec4(color, 1 * exposure * brightness + 1);
}
