#version 430


//###################################################//
//### Inputs/uniforms for our gbuffer pixelshader ###//
//###################################################//
layout(std140, binding = 0) uniform perFrame
{
	mat4x4	vp;
	mat4x4  invVP;

	mat4x4	view;
	mat4x4	invView;
	mat4x4	invTransView;

	mat4x4	proj;
	mat4x4	invProj;

	vec3	eyePos;
	float	gt;
	float	dt;
	uint	screenW;
	uint	screenH;

};


//Simple fullscreen triangle vertexshader
// The (uv-)coordinates are calculated via the vertexID (= 0, 1, 2)
layout(location = 0) out vec2 tex;
layout(location = 1) out vec3 vsViewDirection; // https://community.khronos.org/t/rendering-a-skybox-after-drawing-post-process-effects-to-a-screen-quad/74002/2

void main()
{
	gl_Position.x = float(gl_VertexID / 2) * 4.0 - 1.0; // -1, -3,  3
	gl_Position.y = float(gl_VertexID % 2) * 4.0 - 1.0; // -1,  3, -1
	gl_Position.z = 0.0;
	gl_Position.w = 1.0;
	
	tex.x = float(gl_VertexID / 2) * 2.0; // 0, 0, 2
	tex.y = float(gl_VertexID % 2) * 2.0; // 0, 2, 0
	vsViewDirection = mat3(invView) * (invProj * gl_Position).xyz;
}
