#version 430

#define PI 3.1415926538
#define EPSILON .00001



//###################################################//
//### Inputs/uniforms for our gbuffer pixelshader ###//
//###################################################//
layout(std140, binding = 0) uniform perFrame
{
	mat4x4	vp;
	mat4x4  invVP;

	mat4x4	view;
	mat4x4	invView;
	mat4x4	invTransView;

	mat4x4	proj;
	mat4x4	invProj;

	vec3	eyePos;
	float	gt;
	float	dt;
	uint	screenW;
	uint	screenH;

};

layout(binding = 0) uniform samplerCube texSkybox;

layout(location = 0) in vec3 iTex;

out vec4 outColor;



void main()
{
	vec3 coord = vec3(iTex.x, iTex.y, iTex.z);
	vec3 color = texture(texSkybox, coord).zyx;
	outColor = vec4(color, 1);
}
