#version 430

#define PI 3.1415926538
#define EPSILON .00001



//###################################################//
//### Inputs/uniforms for our gbuffer pixelshader ###//
//###################################################//
layout(std140, binding = 0) uniform perFrame
{
	mat4x4	vp;
	mat4x4  invVP;

	mat4x4	view;
	mat4x4	invView;
	mat4x4	invTransView;

	mat4x4	proj;
	mat4x4	invProj;

	vec3	eyePos;
	float	gt;
	float	dt;
	uint	screenW;
	uint	screenH;

};


layout(location = 0) in vec3 iPosW;

layout(location = 0) out vec3 oTex;



void main()
{
	mat4x4 view4x4 = mat4x4(mat3x3(view));
	vec4 posH = proj * view4x4 * vec4(iPosW, 1);

	gl_Position = posH;

	oTex = iPosW;
}
