#version 430


//###################################################//
//### Inputs/uniforms for our gbuffer pixelshader ###//
//###################################################//
layout(std140, binding = 0) uniform perFrame
{
	mat4x4	vp;
	mat4x4  invVP;

	mat4x4	view;
	mat4x4	invView;
	mat4x4	invTransView;

	mat4x4	proj;
	mat4x4	invProj;

	vec3	eyePos;
	float	gt;
	float	dt;
	uint	screenW;
	uint	screenH;

};

layout(location = 9) uniform vec2 TEXELSIZE;
layout(location = 10) uniform vec3 COLOR = vec3(1);


layout(location = 0) in vec3 iPosW;
layout(location = 1) in vec2 iTex;

layout(binding = 0) uniform sampler2D texGlyph;

layout(location = 0) out vec4 oColor;



float smootherstep(float edge0, float edge1,  float x)
{
	x = clamp((x - edge0) / (edge1 - edge0), 0.0, 1.0);
	// Evaluate polynomial
	return x * x * x * (x * (x * 6 - 15) + 10);
}

vec3 sampleTexture(in vec2 texCoord)
{
	if( true )
	{
		vec3 color = texture(texGlyph, texCoord).xyz;
		color += texture(texGlyph, texCoord + TEXELSIZE * vec2(+.5, +.5)).xyz;
		color += texture(texGlyph, texCoord + TEXELSIZE * vec2(-.5, +.5)).xyz;
		color += texture(texGlyph, texCoord + TEXELSIZE * vec2(+.5, -.5)).xyz;
		color += texture(texGlyph, texCoord + TEXELSIZE * vec2(-.5, -.5)).xyz;
		color /= 5;
		return( color );
	}
	else
	{
		return( texture(texGlyph, texCoord).xyz );
	}
}

void main()
{
	vec3 texColor = sampleTexture(iTex);
	float alpha = (texColor.x + texColor.y + texColor.z) / 3;
//	alpha = alpha * alpha;
//	alpha = smoothstep(0, 1, alpha);
	alpha = smootherstep(0, 1, alpha);
	oColor = vec4(COLOR, alpha);
//	oColor = vec4(iColor, alpha);
}
