#version 430


//###################################################//
//### Inputs/uniforms for our gbuffer pixelshader ###//
//###################################################//
layout(std140, binding = 0) uniform perFrame
{
	mat4x4	vp;
	mat4x4  invVP;

	mat4x4	view;
	mat4x4	invView;
	mat4x4	invTransView;

	mat4x4	proj;
	mat4x4	invProj;

	vec3	eyePos;
	float	gt;
	float	dt;
	uint	screenW;
	uint	screenH;

};

uniform bool isTransformed = false;

layout(location = 0) in vec3 iPos;
layout(location = 1) in vec2 iTex;


layout(location = 0) out vec3 oPosW;
layout(location = 1) out vec2 oTex;

void main()
{
	vec3 posW;
	vec4 posH;
	if( isTransformed )
	{
		posW = vec3(iPos.x, iPos.y, iPos.z);
		posH = vec4(posW, 1);
	}
	else
	{
		posW = vec3(-iPos.x, iPos.y, iPos.z);
		posH = vp * vec4(posW, 1);
	}
	gl_Position = posH;

	oPosW = posW;
	oTex = iTex;
}