#version 430


//#######################################################//
//### Standard inputs/uniforms for every vertexshader ###//
//#######################################################//
layout(std140, binding = 0) uniform perFrame
{
	mat4x4	vp;
	mat4x4  invVP;

	mat4x4	view;
	mat4x4	invView;
	mat4x4	invTransView;

	mat4x4	proj;
	mat4x4	invProj;

	vec3	eyePos;
	float	gt;
	float	dt;
	uint	screenW;
	uint	screenH;

};

layout(location = 1) uniform mat4x4 modelToWorld;
layout(location = 2) uniform mat4x4 modelInvTrans;
layout(location = 3) uniform float iScale = 1.0f;

layout(location = 0) in vec3 iPos;
layout(location = 1) in vec3 iNormal;
layout(location = 2) in vec2 iTex;

layout(location = 0) out vec4 oPosW;
layout(location = 1) out vec4 oPosH;
layout(location = 2) out vec2 oTex;
//#######################################################//
//### Standard inputs/uniforms for every vertexshader ###//
//#######################################################//


// from: https://stackoverflow.com/a/4275343/5587815
float rand(vec2 co){
    return fract(sin(dot(co, vec2(12.9898, 78.233))) * 43758.5453);
}



void main()
{

	vec3 pos = iPos * iScale;
	const float speed = 1.5f;
	const float freq = 2.0f;
	const float amplitude = 45 * rand(vec2(iTex.x, iTex.y));
	pos += iNormal
				* cos(gt * speed + iPos.x * freq)
				* sin(gt * speed + iPos.y * freq)
				* sin(gt * speed + iPos.z * freq)
				* cos(gt * speed + iPos.z * freq)
			* amplitude;


	vec4 posW = modelToWorld * vec4(pos, 1);
	vec4 posH = vp * posW;

	gl_Position = posH;
	oPosW = posW;
	oPosH = posH;
	oTex = iTex;
}
